#!/bin/bash
echo "1.Android 4.4.2"
echo "2.Android 5.x or later"
read -p "Select the platform(1-2):" os_ver

case $os_ver in
	1) os_path=4.4.2 ;;
	2) os_path=5.x ;;
esac

echo "1.arm64-v8a"
echo "2.armeabi-v7a"
echo "3.x86"
echo "4.x86_64"
read -p "Select the platform(1-4):" platform

if [ $platform -lt 1 ] || [ $platform -gt 4 ]; then
	echo "Select the platform error!!!"
	exit 1;
fi

lib_path=x86
if [ $platform = 4 ]; then
	platform=3
	lib_path=x86_64
elif [ $platform = 1 ]; then
	lib_path=arm64-v8a
elif [ $platform = 2 ]; then
	lib_path=armeabi-v7a
fi

if [ $platform = 3 ] 
then
	read -p "Enter the target file name(iso):" filename
	
	if [ "${filename##*.}" != "iso" ]
	then
	  echo "not iso!!!"
	  exit 1;
	fi
   
	if [ ! -f $filename ] 
	then
		echo "file not found!!!"
		exit 1;
	fi		

	echo "Modify system.sfs"
	
	if [ -d android-image ] 
	then
		rm -rf android-image
	fi

	mkdir android-image
	bsdtar -C android-image -xf $filename
	cd android-image
	

	if [ -d /mnt/iso/app ]
	then
		sudo umount /mnt/iso/
	fi
	
	if [ ! -d /mnt/iso ]
	then
		sudo mkdir /mnt/iso
	fi
	
	sleep 1

	if [ -f ./system.sfs ]
	then
		unsquashfs -f system.sfs
		sudo mount ./squashfs-root/system.img /mnt/iso  -o loop
	else
		sudo mount ./system.img /mnt/iso  -o loop
	fi
	
	
	if [ -d ~/Temp/boot ]
	then
		rm -rf ~/Temp/boot
	fi
	
	mkdir -p ~/Temp/boot
	cp -rf isolinux ~/Temp/boot
	
	if [ -d /mnt/iso/app ]
	then
		echo ===$lib_path===
		sudo cp ../$os_path/Calibrate/Calibrate.apk /mnt/iso/app/
		sudo cp ../$os_path/Calibrate/$lib_path/libcalib-second.so /mnt/iso/lib/
		sudo cp ../$os_path/Touchtool/TouchTool.apk /mnt/iso/app/
	fi
	
	if [ -d /mnt/iso/usr/idc ]
	then
		sudo cp ../idc/*.idc /mnt/iso/usr/idc/
	fi	
	
	sudo umount /mnt/iso/
	
	sleep 1
	if [ -f ./system.sfs ]
	then	
		rm system.sfs
		mksquashfs squashfs-root/system.img system.sfs
	fi
	
	echo "Modify ramdisk.img"
	cp ./ramdisk.img ./ramdisk.img.old
	mv ./ramdisk.img ./ramdisk.img.gz
	gzip -d ramdisk.img.gz	
	
	if [ -d ramdisk ]
	then
		rm -rf ramdisk
	fi
		
	mkdir ramdisk
	cd ramdisk
	cpio -i -F ../ramdisk.img
	gedit ueventd.rc
	cpio -i -t -F ../ramdisk.img >list
	cpio -o -H newc -O ramdisk.img <list
	gzip ramdisk.img
	mv ramdisk.img.gz ramdisk.img
	
	rm ../ramdisk.img
	cp ramdisk.img ../ramdisk.img
	cd ..
	
	echo "create $filename"
	cd ..
	mv $filename $filename.old
	if [ -f android-image/system.sfs ]
	then
		genisoimage -vJURT -b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table -input-charset utf-8 -V "Android-x86 LiveCD" -o $filename ~/Temp/boot/ android-image/ramdisk.img android-image/initrd.img android-image/install.img android-image/system.sfs android-image/kernel
	else
		genisoimage -vJURT -b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table -input-charset utf-8 -V "Android-x86 LiveCD" -o $filename ~/Temp/boot/ android-image/ramdisk.img android-image/initrd.img android-image/install.img android-image/system.img android-image/kernel
	fi
	rm -rf android-image/
	echo "***$filename created successfully***"
	exit 1;
fi

GetPackFormat(){
	local array=( gzip u-boot data VMS )
	for ((i=0;i<4;i++));	
	do
		#echo ${array[i]}
		file $1 >type.txt
		local ret=$(grep -ic ${array[i]} type.txt)
		#echo $ret
		rm -f type.txt
		if [  "$ret" = "1"  ]; then
			return $i
		fi
	done
	return 4;
}

UnpackExt4System(){
	sudo chmod 777 ./make_ext4fs
	sudo chmod 777 ./simg2img
	echo "Modify system.img"
	rm -rf system
	mkdir system

	if [ -f system.img ] 
	then
		./simg2img system.img system-raw.img
	else
		echo "system.img not found!!!"
		exit 1
	fi

	mount -t ext4 -o loop system-raw.img system
	
	cd system
	
	if [ -d ./app/ ] 
	then
		cp ../$os_path/Calibrate/Calibrate.apk ./app/
		cp ../$os_path/Touchtool/TouchTool.apk ./app/	
	else
		echo "system.img type does not match!!!"
		exit 1
	fi

	if [ -d ./idc/ ]
	then
		sudo cp ../idc/*.idc ./idc/
	fi

	cp ../$os_path/Calibrate/$lib_path/libcalib-second.so ./lib/

	cd ..
	mv system.img system.img.old
	./make_ext4fs -s -l 512M -a system system.img system
	umount system/
	rm -rf system/
	rm -f system-raw.img
	echo "system.img created successfully"
}

UnpackYaffsSystem(){
	sudo chmod 777 ./unyaffs
	sudo chmod 777 ./mkyaffs2image
	echo "Modify yaffs system.img"
	rm -rf system
	mkdir system

	cd system

	if [ -f ../system.img ] 
	then
		../unyaffs ../system.img
	else
		echo "system.img not found!!!"
		exit 1
	fi

	if [ -d ./app/ ] 
	then
		cp ../$os_path/Calibrate/Calibrate.apk ./app/
		cp ../$os_path/Touchtool/TouchTool.apk ./app/
	else
		echo "system.img type does not match!!!"
		exit 1
	fi

	if [ -d ./idc/ ]
	then
		sudo cp ../idc/*.idc ./idc/
	fi

	cp ../$os_path/Calibrate/$lib_path/libcalib-second.so ./lib/

	cd ..
	mv system.img system.img.old
	./mkyaffs2image -f ./system system.img
	echo "system.img created successfully"
}

EditUbootRamDisk(){
echo "Modify u-boot ramdisk.img"
	if [ -f ./ramdisk.img ]; then
		cp -f ramdisk.img ramdisk.img.old
		mkdir ramdisk
		cd ramdisk
		dd if=../ramdisk.img bs=64 skip=1 of=ramdisk.gz 
		gzip -dc ramdisk.gz | cpio -idmv
		rm ramdisk.gz
		gedit ueventd.rc

		find . | cpio -o -H newc -C 512 | gzip -n > ../ramdisk.cpio.gz
		cd ..
		mkimage -A ARM -O Linux -T ramdisk -C none -a 0x41000000 -e 0x41000000 -n hRamdisk -d ramdisk.cpio.gz ramdisk.img
		rm ramdisk.cpio.gz
		rm -rf ramdisk
		echo "ramdisk.img created successfully"
	fi
}

EditGzipRamDisk(){
	echo "Modify gzip ramdisk.img"
	if [ -f ../ramdisk.img ]; then
		cp ./ramdisk.img ./ramdisk.img.old
		mv ./ramdisk.img ./ramdisk.img.gz
		gzip -d ramdisk.img.gz	
		
		if [ -d ramdisk ];	then
			rm -rf ramdisk
		fi
			
		mkdir ramdisk
		cd ramdisk
		cpio -i -F ../ramdisk.img
		gedit ueventd.rc
		cpio -i -t -F ../ramdisk.img >list
		cpio -o -H newc -O ramdisk.img <list
		gzip ramdisk.img
		mv ramdisk.img.gz ramdisk.img
		
		rm ../ramdisk.img
		cp ramdisk.img ../ramdisk.img
		cd ..
		rm -rf ramdisk
		echo "ramdisk.img created successfully"
	fi
}


GetPackFormat ramdisk.img
r=$?
if [  "$r" = "0"  ]; then	
	EditGzipRamDisk
elif [  "$r" = "1"  ]; then
	EditUbootRamDisk
fi

GetPackFormat system.img
r=$?
if [  "$r" = "2"  ]; then	
	UnpackExt4System
elif [  "$r" = "3"  ]; then
	UnpackYaffsSystem
fi

